`timescale 1ns / 1ps
//*****************************************************************************
// File Name            : mbmcs_vag_ap.v
//-----------------------------------------------------------------------------
// Function             : mbmcs_vag_ap
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2013/01/10 
// -.-- 2013/02/17 
//*****************************************************************************
module mbmcs_vga_ap (
 clk_100m, reset,UART_Tx, UART_Rx, led,
 //clk_p, 
 //hsync, vsync, blank, red_da, green_da, blue_da,
 //DVI
 DVI_TX0_P,DVI_TX1_P,DVI_TX2_P,DVI_TXC_P,
 //LPDDR
 mcb3_dram_dq,   
 mcb3_dram_a,    
 mcb3_dram_ba,                   
 mcb3_dram_cke,  
 mcb3_dram_ras_n,
 mcb3_dram_cas_n,
 mcb3_dram_we_n, 
 mcb3_dram_dm,   
 mcb3_dram_udqs, 
 mcb3_rzq,       
 mcb3_dram_udm,  
 mcb3_dram_dqs,  
 mcb3_dram_ck,   
 mcb3_dram_ck_n,
 //code913 clk generator
 code913_S1,
 code913_S2,
 //monitor                 
 mon
);
  // 
  parameter     LINE_FIFO_AWIDTH = 7;
  //whishbone_baseaddr = 0xC0000000
  parameter vram_baseaddr =   4'hC ;   
  parameter sgpio_baseaddr =  20'hD0000 ;
  parameter vga_baseaddr =    20'hD0001 ;
  //
  input clk_100m;  //clk 100MHz
  input reset;
  //UART
  input UART_Rx;
  output UART_Tx;
  //LED
  output [3:0] led;
  //VGA 
  /*  
  output        hsync;               // horizontal sync
  output        vsync;               // vertical sync
  output        blank;               // blanking signal
  output [ 3:0] red_da, green_da, blue_da; // RGB color signals
  */
  //dvi
  output        DVI_TX0_P;
  output        DVI_TX1_P;
  output        DVI_TX2_P;
  output        DVI_TXC_P;
  //lpddr 
  inout [15:0] mcb3_dram_dq;   
  output [12:0]              mcb3_dram_a;    
  output [1:0]               mcb3_dram_ba;   
  output                     mcb3_dram_cke;  
  output                     mcb3_dram_ras_n;
  output                     mcb3_dram_cas_n;
  output                     mcb3_dram_we_n; 
  output                     mcb3_dram_dm;   
  inout                      mcb3_dram_udqs; 
  inout                      mcb3_rzq;       
  output                     mcb3_dram_udm;  
  inout                      mcb3_dram_dqs;  
  output                     mcb3_dram_ck;   
  output                     mcb3_dram_ck_n;  
  //code913 clk generator
  output                     code913_S1;
  output                     code913_S2;
  //monitor     
  output mon;

  wire  clk_100m_i;  //100MHz clk
  wire  resetb; 
  wire  locked; 
  //IO bus
  wire IO_Addr_Strobe;
  wire IO_Read_Strobe;
  wire IO_Write_Strobe;
  wire IO_Ready;
  wire  [31 : 0] IO_Read_Data;
  wire [31 : 0] IO_Address;
  wire [3 : 0] IO_Byte_Enable;
  wire [31 : 0] IO_Write_Data;
  //Wishbone bus microblaze -> IP
  wire         clk_i;         // clock 
  wire         rst_i;         // reset (asynchronous active hi)
  wire         rstb_i;         // reset (asynchronous active low)
  wire         cyc_i;         // cycle
  wire         cyc_i_sgpio;         // cycle
  wire         cyc_i_vga;         // cycle
  wire         cyc_i_vram;         // cycle
  wire         stb_i;         // strobe
  wire         stb_i_sgpio;         // strobe
  wire         stb_i_vga;         // strobe
  wire         stb_i_vram;         // strobe
  wire  [31:0]  adr_i;         // address adr_i[1]
  wire         we_i;          // write enable
  wire         we_i_sgpio;          // write enable
  wire         we_i_vga;          // write enable
  wire         we_i_vram;          // write enable
  wire  [ 31:0] dat_i;         // data output
  wire  [ 7:0]  dat_i_sgpio;   // data output
  wire  [ 31:0] dat_o;         // data input
  wire  [ 31:0] dat_o_vga;     // data input
  wire  [ 7:0]  dat_o_sgpio;   // data input
  wire  [3:0]   sel_i;       // byte enable
  wire        ack_o;         // normal bus termination
  wire        ack_o_sgpio;         // normal bus termination
  wire        ack_o_vga;         // normal bus termination
  wire         ack_o_vram;         // normal bus termination
  wire        int;
  wire        rty_o;
  wire        err_o_vga;
  wire        ack_err_o_vga;
  wire       sgpio_sel;
  wire       vga_sel;
  wire       vram_sel;
  //Wishbone bus vga_enh_top -> vram  
  wire    [31:0]  wb_addr_o;
  wire    [31:0]  wb_data_i;
  reg     [31:0]  wb_data_i_dmy;
  wire    [31:0]  wb_data_o;
  wire    [3:0]   wb_sel_o;
  wire            wb_we_o;
  wire            wb_stb_o;
  wire            wb_cyc_o;
  wire    [2:0]   wb_cti_o;
  wire    [1:0]   wb_bte_o;
  wire            wb_ack_i;
  wire            wb_err_i=1'b0;
  wire            wb_ack_o_vram;
  //MicroBlaze MCS gpio 
  wire GPI1_Interrupt;
  wire [31 : 0] gpo;
  wire [31 : 0] gpi; 
  //opencores simple_gpio  
  wire  [7:0] sgpio;
  // 
  //video
  wire            pclk_i;   //40MHz CLK
  wire            pclk_ix5; //pclk_i x5
  wire            clk_p;                   // VGA pixel clock output 
  reg            hsync;               // horizontal sync
  reg            vsync;               // vertical sync
  wire           hsync_w;               // horizontal sync
  wire           vsync_w;               // vertical sync 
  wire           csync;               // composite sync
  reg            blank;               // blanking signal
  wire           blank_w;               // blanking signal
  wire   [ 7:0]  red, green, blue; // RGB color signals
  wire   da_en;
   
  reg   [ 3:0]   red_da, green_da, blue_da; // RGB color signals
   
  //lpddr
  wire            c3_sys_clk; //200MHz lpddr
  wire        c3_p0_cmd_clk;
  wire        c3_p0_cmd_en;
  wire [2:0]  c3_p0_cmd_instr;
  wire [5:0]  c3_p0_cmd_bl;
  wire [29:0] c3_p0_cmd_byte_addr;
  wire         c3_p0_cmd_empty;
  wire         c3_p0_cmd_full;
  wire        c3_p0_wr_clk;
  wire        c3_p0_wr_en;
  wire [3:0]  c3_p0_wr_mask;
  wire [31:0] c3_p0_wr_data;
  wire         c3_p0_wr_full;
  wire         c3_p0_wr_empty;
  wire [6:0]   c3_p0_wr_count;
  reg [6:0]   c3_p0_wr_count_d1;
  wire         c3_p0_wr_underrun;
  wire         c3_p0_wr_error;
  wire        c3_p0_rd_clk;
  wire        c3_p0_rd_en;
  wire [31:0]  c3_p0_rd_data;
  wire         c3_p0_rd_full;
  wire         c3_p0_rd_empty;
  wire [6:0]   c3_p0_rd_count;
  reg [6:0]   c3_p0_rd_count_d1;
  wire         c3_p0_rd_overflow;
  wire        c3_p0_rd_error  ;
  wire        c3_p1_cmd_clk;
  wire        c3_p1_cmd_en = 0 ;
  wire [2:0]  c3_p1_cmd_instr = 0 ;
  wire [5:0]  c3_p1_cmd_bl = 0 ;
  wire [29:0] c3_p1_cmd_byte_addr = 0 ;
  wire         c3_p1_cmd_empty;
  wire         c3_p1_cmd_full;
  wire        c3_p1_wr_clk = 0 ;
  wire        c3_p1_wr_en = 0 ;
  wire [3:0]  c3_p1_wr_mask = 0 ;
  wire [31:0] c3_p1_wr_data = 0 ;
  wire         c3_p1_wr_full;
  wire         c3_p1_wr_empty;
  wire [6:0]   c3_p1_wr_count;
  reg [6:0]   c3_p1_wr_count_d1;
  wire         c3_p1_wr_underrun;
  wire         c3_p1_wr_error;
  wire        c3_p1_rd_clk = 0 ;
  wire        c3_p1_rd_en = 0 ;
  wire [31:0]  c3_p1_rd_data;
  wire         c3_p1_rd_full;
  wire         c3_p1_rd_empty;
  wire [6:0]   c3_p1_rd_count;
  reg [6:0]   c3_p1_rd_count_d1;
  wire         c3_p1_rd_overflow;
  wire        c3_p1_rd_error  ;
  wire        c3_calib_done  ;

  //reset 
  assign resetb = ~reset;
  assign reset_locked =((resetb==1'b0)||(locked==1'b0))?1'b1:1'b0;
  assign resetb_locked = ~reset_locked ;
  assign rstb_i = ~rst_i;

  //code913
  assign code913_S1 =1'b1;
  assign code913_S2 =1'b1;
   
  //gpio     
  assign gpi = gpo;
  
  //led
  assign led ={sgpio[1:0],gpo[1:0]};
   
  //wishbone MicorBkaze -> IP
  //select module   
  assign sgpio_sel=(adr_i[31:12]== sgpio_baseaddr)?1'b1:1'b0;
  assign vga_sel  =(adr_i[31:12]== vga_baseaddr)?1'b1:1'b0;
  assign vram_sel =(adr_i[31:28]== vram_baseaddr)?1'b1:1'b0; //base_adr = 0xC0000000
 
  //read data
  assign dat_o = (sgpio_sel==1'b1)?{16'h000000,dat_o_sgpio,dat_o_sgpio}:
                 (vga_sel==1'b1)  ?dat_o_vga:
                                   32'h00000000 ;  
  //ack 
  assign ack_o = (sgpio_sel==1'b1)?ack_o_sgpio:
                 (vga_sel==1'b1)  ?ack_err_o_vga:
                 (vram_sel==1'b1) ?ack_o_vram:
                                   stb_i;
 
  assign ack_err_o_vga = ((ack_o_vga==1'b1)||(err_o_vga==1'b1))?1'b1:1'b0;
       
  assign stb_i_sgpio = (sgpio_sel==1'b1)?stb_i:1'b0;
  assign stb_i_vga =  (vga_sel==1'b1)?stb_i:1'b0;
  assign stb_i_vram = (vram_sel==1'b1)?stb_i:1'b0;
  assign cyc_i_sgpio = (sgpio_sel==1'b1)?cyc_i:1'b0;
  assign cyc_i_vga =  (vga_sel==1'b1)?cyc_i:1'b0;
  assign cyc_i_vram = (vram_sel==1'b1)?cyc_i:1'b0;
  assign we_i_sgpio =  (sgpio_sel==1'b1)?we_i:1'b0;
  assign we_i_vga =  (vga_sel==1'b1)?we_i:1'b0;
  assign we_i_vram = (vram_sel==1'b1)?we_i:1'b0;

  //Wishbone bus vga_enh_top <- vram
  assign wb_ack_i = wb_ack_o_vram;

  //vga
  always @ (posedge pclk_i )
    begin
      vsync <= vsync_w;
      hsync <= hsync_w;
      blank <= blank_w;
      if (blank_w==1'b0) begin
         red_da <= red[7:4];
         green_da <= green[7:4];
         blue_da <= blue[7:4];
      end
      else begin
        red_da <= 4'h0;
        green_da <= 4'h0;
        blue_da <= 4'h0;
      end        
    end // always @ (posedge pclk_i )
   
  //mon   
  assign mon = GPI1_Interrupt ^ err_o_vga  ;
   
clk_gen clk_gen
   (// Clock in ports
   .CLK_IN1(clk_100m),      // IN  100MHz
   // Clock out ports
   .CLK_OUT1(clk_100m_i),   // OUT 100MHz
   .CLK_OUT2(pclk_i),     // OUT 40MHz
   .CLK_OUT3(pclk_ix5),       // OUT 200MHz
   .CLK_OUT4(pclk_x2),      // OUT  80MHz
   .CLK_OUT5(c3_sys_clk),   // OUT 200MHz lpddr clk
   // Status and control signals
   .RESET(reset ),          // IN
   .LOCKED(locked)          // OUT 
    );
   
mb_mcs mcs_0 (
  .Clk(clk_100m_i), // input Clk
  .Reset(reset_locked), // input Reset
  .IO_Addr_Strobe(IO_Addr_Strobe), // output IO_Addr_Strobe
  .IO_Read_Strobe(IO_Read_Strobe), // output IO_Read_Strobe
  .IO_Write_Strobe(IO_Write_Strobe), // output IO_Write_Strobe
  .IO_Address(IO_Address), // output [31 : 0] IO_Address
  .IO_Byte_Enable(IO_Byte_Enable), // output [3 : 0] IO_Byte_Enable
  .IO_Write_Data(IO_Write_Data), // output [31 : 0] IO_Write_Data
  .IO_Read_Data(IO_Read_Data), // input [31 : 0] IO_Read_Data
  .IO_Ready(IO_Ready), // input IO_Ready
  .UART_Rx(UART_Rx), // input UART_Rx
  .UART_Tx(UART_Tx), // output UART_Tx
  .GPO1(gpo), // output [31 : 0] GPO1
  .GPI1(gpi), // input [31 : 0] GPI1
  .GPI1_Interrupt(GPI1_Interrupt) // output GPI1_Interrupt
              );
      
iobus2wb iobus2wb(
  .Clk(clk_100m_i), // input Clk
  .Reset(reset_locked), // input Reset
  .IO_Addr_Strobe(IO_Addr_Strobe), // output IO_Addr_Strobe
  .IO_Read_Strobe(IO_Read_Strobe), // output IO_Read_Strobe
  .IO_Write_Strobe(IO_Write_Strobe), // output IO_Write_Strobe
  .IO_Address(IO_Address), // output [31 : 0] IO_Address
  .IO_Byte_Enable(IO_Byte_Enable), // output [3 : 0] IO_Byte_Enable
  .IO_Write_Data(IO_Write_Data), // output [31 : 0] IO_Write_Data
  .IO_Read_Data(IO_Read_Data), // input [31 : 0] IO_Read_Data
  .IO_Ready(IO_Ready), // input IO_Ready
  //wishbone MicorBlaze -> IP
  .clk_o(clk_i),         // clock
  .rst_o(rst_i),         // reset (asynchronous active low)
  .cyc_o(cyc_i),         // cycle
  .stb_o(stb_i),         // strobe
  .adr_o(adr_i),         // address adr_i[1]
  .sel_o(sel_i),         // byte_sel
  .we_o(we_i),          // write enable
  .dat_o(dat_i),         // data output
  .dat_i(dat_o),         // data input
  .ack_i(ack_o)         // normal bus termination
                  );
  
//opencores simple_gpio    
 simple_gpio simple_gpio(
  .clk_i(clk_i),         // clock
  .rst_i(rstb_i),         // reset (asynchronous active low)
  .cyc_i(cyc_i_sgpio),         // cycle
  .stb_i(stb_i_sgpio),         // strobe
  .adr_i(adr_i[0]),         // address adr_i[1]
  .we_i(we_i_sgpio),          // write enable
  .dat_i(dat_i[7:0]),         // data output
  .dat_o(dat_o_sgpio),         // data input
  .ack_o(ack_o_sgpio),         // normal bus termination
  .gpio(sgpio)
                         );
        
vga_enh_top #(1'b0, LINE_FIFO_AWIDTH) u0 (
  .wb_clk_i     ( clk_i             ),
  .wb_rst_i     ( 1'b0            ),
  .rst_i        ( rstb_i           ),
  .wb_inta_o    ( int             ),
  // WHISHBONE slave signals
  .wbs_adr_i    ( adr_i[11:0] ),
  .wbs_dat_i    ( dat_i       ),
  .wbs_dat_o    ( dat_o_vga    ),
  .wbs_sel_i    ( sel_i        ), //
  .wbs_we_i     ( we_i_vga         ),
  .wbs_stb_i    ( stb_i_vga        ),
  .wbs_cyc_i    ( cyc_i_vga        ),
  .wbs_ack_o    ( ack_o_vga    ),
  .wbs_rty_o    ( rty_o        ), //
  .wbs_err_o    ( err_o_vga    ), //
  // WHISHBONE signals
  .wbm_adr_o    ( wb_addr_o[31:0] ),
  .wbm_dat_i    ( wb_data_i      ),
  .wbm_sel_o    ( wb_sel_o        ),
  .wbm_we_o     ( wb_we_o         ),
  .wbm_stb_o    ( wb_stb_o        ),
  .wbm_cyc_o    ( wb_cyc_o        ),
  .wbm_cti_o    ( wb_cti_o        ),
  .wbm_bte_o    ( wb_bte_o        ),
  .wbm_ack_i    ( wb_ack_i        ),
  .wbm_err_i    ( wb_err_i        ),
  //-- VGA signals 
  .clk_p_i      ( pclk_i          ),
  .clk_p_o      ( clk_p           ),
  .hsync_pad_o  ( hsync_w           ),
  .vsync_pad_o  ( vsync_w           ),
  .csync_pad_o  ( csync           ),
  .blank_pad_o  ( blank_w           ),
  .r_pad_o      ( red             ),
  .g_pad_o      ( green           ),
  .b_pad_o      ( blue            )
  );

//vram controller
wb_2_mig  wb_2_mig (
  .clk_i(clk_i),         // clock
  .rst_i(rstb_i),         // reset (asynchronous active low)
  .w_cyc_i(cyc_i_vram),         // cycle
  .w_stb_i(stb_i_vram),         // strobe
  .w_adr_i(adr_i[27:0]),         // address adr_i[1]
  .w_we_i(we_i_vram),          // write enable
  .w_dat_i(dat_i),         // 
  .w_ack_o(ack_o_vram),         // normal bus termination
  .r_cyc_i(wb_cyc_o),         // cycle
  .r_stb_i(wb_stb_o),         // strobe
  .r_adr_i(wb_addr_o[27:0]),         // address adr_i[1]
  .r_we_i(wb_we_o),          // write enable
  .r_dat_o(wb_data_i ),         // data input
  .r_ack_o(wb_ack_o_vram),         // normal bus termination
  //mig if
  //.clk(      c3_clk0), 
  .clk(      clk_i),            
  .reset_n(  resetb_locked),
  .c3_p0_cmd_clk                          (c3_p0_cmd_clk),
  .c3_p0_cmd_en                           (c3_p0_cmd_en),
  .c3_p0_cmd_instr                        (c3_p0_cmd_instr),
  .c3_p0_cmd_bl                           (c3_p0_cmd_bl),
  .c3_p0_cmd_byte_addr                    (c3_p0_cmd_byte_addr),
  .c3_p0_cmd_empty                        (c3_p0_cmd_empty),
  .c3_p0_cmd_full                         (c3_p0_cmd_full),
  .c3_p0_wr_clk                           (c3_p0_wr_clk),
  .c3_p0_wr_en                            (c3_p0_wr_en),
  .c3_p0_wr_mask                          (c3_p0_wr_mask),
  .c3_p0_wr_data                          (c3_p0_wr_data),
  .c3_p0_wr_full                          (c3_p0_wr_full),
  .c3_p0_wr_empty                         (c3_p0_wr_empty),
  .c3_p0_wr_count                         (c3_p0_wr_count),
  .c3_p0_wr_underrun                      (c3_p0_wr_underrun),
  .c3_p0_wr_error                         (c3_p0_wr_error),
  .c3_p0_rd_clk                           (c3_p0_rd_clk),
  .c3_p0_rd_en                            (c3_p0_rd_en),
  .c3_p0_rd_data                          (c3_p0_rd_data),
  .c3_p0_rd_full                          (c3_p0_rd_full),
  .c3_p0_rd_empty                         (c3_p0_rd_empty),
  .c3_p0_rd_count                         (c3_p0_rd_count),
  .c3_p0_rd_overflow                      (c3_p0_rd_overflow),
  .c3_p0_rd_error                         (c3_p0_rd_error),
  /*
  .c3_p1_cmd_clk                          (c3_p1_cmd_clk),
  .c3_p1_cmd_en                           (c3_p1_cmd_en),
  .c3_p1_cmd_instr                        (c3_p1_cmd_instr),
  .c3_p1_cmd_bl                           (c3_p1_cmd_bl),
  .c3_p1_cmd_byte_addr                    (c3_p1_cmd_byte_addr),
  .c3_p1_cmd_empty                        (c3_p1_cmd_empty),
  .c3_p1_cmd_full                         (c3_p1_cmd_full),
  .c3_p1_wr_clk                           (c3_p1_wr_clk),
  .c3_p1_wr_en                            (c3_p1_wr_en),
  .c3_p1_wr_mask                          (c3_p1_wr_mask),
  .c3_p1_wr_data                          (c3_p1_wr_data),
  .c3_p1_wr_full                          (c3_p1_wr_full),
  .c3_p1_wr_empty                         (c3_p1_wr_empty),
  .c3_p1_wr_count                         (c3_p1_wr_count),
  .c3_p1_wr_underrun                      (c3_p1_wr_underrun),
  .c3_p1_wr_error                         (c3_p1_wr_error),
  .c3_p1_rd_clk                           (c3_p1_rd_clk),
  .c3_p1_rd_en                            (c3_p1_rd_en),
  .c3_p1_rd_data                          (c3_p1_rd_data),
  .c3_p1_rd_full                          (c3_p1_rd_full),
  .c3_p1_rd_empty                         (c3_p1_rd_empty),
  .c3_p1_rd_count                         (c3_p1_rd_count),
  .c3_p1_rd_overflow                      (c3_p1_rd_overflow),
  .c3_p1_rd_error                         (c3_p1_rd_error),
   */
  .c3_calib_done          (c3_calib_done)
                         );
//mig
   parameter DEBUG_EN              = 0;
   parameter C3_MEMCLK_PERIOD      = 5000;
   parameter C3_RST_ACT_LOW        = 0;
   parameter C3_INPUT_CLK_TYPE     = "SINGLE_ENDED";
   parameter C3_NUM_DQ_PINS        = 16;
   parameter C3_MEM_ADDR_WIDTH     = 13;
   parameter C3_MEM_BANKADDR_WIDTH = 2;   
   parameter C3_MEM_ADDR_ORDER     = "ROW_BANK_COLUMN"; 
   parameter C3_P0_MASK_SIZE       = 4;
   parameter C3_P0_DATA_PORT_SIZE  = 32;  
   parameter C3_P1_MASK_SIZE       = 4;
   parameter C3_P1_DATA_PORT_SIZE  = 32;
   parameter C3_MEM_BURST_LEN     = 4;
   parameter C3_MEM_NUM_COL_BITS   = 10;
   parameter C3_CALIB_SOFT_IP      = "TRUE";  
   parameter C3_SIMULATION      = "TRUE";
   parameter C3_HW_TESTING      = "FALSE";
   parameter C3_SMALL_DEVICE    = "FALSE";
   
lpddr_if #(
.C3_P0_MASK_SIZE       (C3_P0_MASK_SIZE      ),
.C3_P0_DATA_PORT_SIZE  (C3_P0_DATA_PORT_SIZE ),
.C3_P1_MASK_SIZE       (C3_P1_MASK_SIZE      ),
.C3_P1_DATA_PORT_SIZE  (C3_P1_DATA_PORT_SIZE ),
.C3_MEMCLK_PERIOD      (C3_MEMCLK_PERIOD),
.C3_RST_ACT_LOW        (C3_RST_ACT_LOW),
.C3_INPUT_CLK_TYPE     (C3_INPUT_CLK_TYPE),
.DEBUG_EN              (DEBUG_EN),
.C3_MEM_ADDR_ORDER     (C3_MEM_ADDR_ORDER    ),
.C3_NUM_DQ_PINS        (C3_NUM_DQ_PINS       ),
.C3_MEM_ADDR_WIDTH     (C3_MEM_ADDR_WIDTH    ),
.C3_MEM_BANKADDR_WIDTH (C3_MEM_BANKADDR_WIDTH),
.C3_SIMULATION         (C3_SIMULATION),
.C3_CALIB_SOFT_IP      (C3_CALIB_SOFT_IP )
)
lpddr_if_0  (
  .c3_sys_clk             (c3_sys_clk),
  .c3_sys_rst_i           (reset_locked),                        
  .mcb3_dram_dq           (mcb3_dram_dq),  
  .mcb3_dram_a            (mcb3_dram_a),  
  .mcb3_dram_ba           (mcb3_dram_ba),
  .mcb3_dram_ras_n        (mcb3_dram_ras_n),                        
  .mcb3_dram_cas_n        (mcb3_dram_cas_n),                        
  .mcb3_dram_we_n         (mcb3_dram_we_n),                          
  .mcb3_dram_cke          (mcb3_dram_cke),                          
  .mcb3_dram_ck           (mcb3_dram_ck),                          
  .mcb3_dram_ck_n         (mcb3_dram_ck_n),       
  .mcb3_dram_dqs          (mcb3_dram_dqs),
  .mcb3_dram_udqs         (mcb3_dram_udqs),    // for X16 parts
  .mcb3_dram_udm          (mcb3_dram_udm),     // for X16 parts
  .mcb3_dram_dm           (mcb3_dram_dm),
  .c3_clk0                (c3_clk0),
  .c3_rst0                (c3_rst0),
  .c3_calib_done          (c3_calib_done),
  //.mcb3_rzq               (rzq3),
  .mcb3_rzq               (mcb3_rzq),
  .c3_p0_cmd_clk                          (c3_p0_cmd_clk),
  .c3_p0_cmd_en                           (c3_p0_cmd_en),
  .c3_p0_cmd_instr                        (c3_p0_cmd_instr),
  .c3_p0_cmd_bl                           (c3_p0_cmd_bl),
  .c3_p0_cmd_byte_addr                    (c3_p0_cmd_byte_addr),
  .c3_p0_cmd_empty                        (c3_p0_cmd_empty),
  .c3_p0_cmd_full                         (c3_p0_cmd_full),
  .c3_p0_wr_clk                           (c3_p0_wr_clk),
  .c3_p0_wr_en                            (c3_p0_wr_en),
  .c3_p0_wr_mask                          (c3_p0_wr_mask),
  .c3_p0_wr_data                          (c3_p0_wr_data),
  .c3_p0_wr_full                          (c3_p0_wr_full),
  .c3_p0_wr_empty                         (c3_p0_wr_empty),
  .c3_p0_wr_count                         (c3_p0_wr_count),
  .c3_p0_wr_underrun                      (c3_p0_wr_underrun),
  .c3_p0_wr_error                         (c3_p0_wr_error),
  .c3_p0_rd_clk                           (c3_p0_rd_clk),
  .c3_p0_rd_en                            (c3_p0_rd_en),
  .c3_p0_rd_data                          (c3_p0_rd_data),
  .c3_p0_rd_full                          (c3_p0_rd_full),
  .c3_p0_rd_empty                         (c3_p0_rd_empty),
  .c3_p0_rd_count                         (c3_p0_rd_count),
  .c3_p0_rd_overflow                      (c3_p0_rd_overflow),
  .c3_p0_rd_error                         (c3_p0_rd_error)
);


assign    da_en = ~blank_w;
      
xil_dvi #(
        .differential(0)                                // select diff=1 , single_end=0
) dvi_out (
        .DVI_TX0_N(),                                   // out   [TX] TX[0]-N (CML)
        .DVI_TX0_P(DVI_TX0_P),              // out   [TX] TX[0]-P (CML)
        .DVI_TX1_N(),                                   // out   [TX] TX[1]-N (CML)
        .DVI_TX1_P(DVI_TX1_P),              // out   [TX] TX[1]-P (CML)
        .DVI_TX2_N(),                                   // out   [TX] TX[2]-N (CML)
        .DVI_TX2_P(DVI_TX2_P),              // out   [TX] TX[2]-P (CML)
        .DVI_TXC_N(),                                   // out   [TX] TX_CLK-N (CML)
        .DVI_TXC_P(DVI_TXC_P),             // out   [TX] TX_CLK-P (CML)

        .TX_RED(red),                   // in    [TX] [7:0] red
        .TX_GRN(green),                   // in    [TX] [7:0] green
        .TX_BLU(blue),                   // in    [TX] [7:0] blue
        .TX_HS(hsync_w),                                  // in    [TX] hsync
        .TX_VS(vsync_w),                                  // in    [TX] vsync
        .TX_C0(1'b0),                                   // in    [TX] c0
        .TX_C1(1'b0),                                   // in    [TX] c1
        .TX_C2(1'b0),                                   // in    [TX] c2
        .TX_C3(1'b0),                                   // in    [TX] c3
        .TX_DE(da_en),                                  // in    [TX] de

        .CLK(pclk_i),                                    // in    [DVI] clk
        .CLKx5(!pclk_ix5),                               // in    [DVI] clk x5 : dvi ddr
        .RESET_N(resetb_locked)                                 // in    [DVI] #reset
);

      
  
endmodule

