//*****************************************************************************
// File Name            : svga_sw1.c
//-----------------------------------------------------------------------------
// Function             : OpenCores VGA core softeare
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo
//-----------------------------------------------------------------------------
// History
// -.-- 2014/04/22
//*****************************************************************************


#ifdef __hal__
  #include "sys/alt_stdio.h"
  #include "system.h"
  // BASEADDR
  #define VRAM_BASEADDR    0x40000000
  #define SGPIO_BASEADDR   0x50000000
  #define  VGA_BASEADDR 0x50001000
  // PRINT macro
  #define M_PRINT(str)  alt_putstr(str);
  #define M_PRINTF(str, ...) printf(str, __VA_ARGS__);
#elif __microblaze__
  #include <stdio.h>
  #include "platform.h"
  #include "xbasic_types.h"
  #include "XIOModule.h"
  // BASEADDR
  //@}N` IOoXł̃AhX
  #define VRAM_BASEADDR    0xC0000000
  #define SGPIO_BASEADDR   0xD0000000
  #define VGA_BASEADDR 0xD0001000
  // PRINT macro
  #define M_PRINT(str)  print(str);
  #define M_PRINTF(str, ...) xil_printf(str, __VA_ARGS__);
#endif

//VGA Core ̃WX^`
#define VGA_CTRL  (*(volatile unsigned int *) (VGA_BASEADDR +  0x0))
#define VGA_HTIM  (*(volatile unsigned int *) (VGA_BASEADDR +  0x8))
#define VGA_VTIM  (*(volatile unsigned int *) (VGA_BASEADDR +  0xC))
#define VGA_HVLEN   (*(volatile unsigned int *) (VGA_BASEADDR + 0x10))
#define VGA_VBARA   (*(volatile unsigned int *) (VGA_BASEADDR + 0x14))
#define VGA_VBARB   (*(volatile unsigned int *) (VGA_BASEADDR + 0x18))
#define VGA_VRAM_BASEADDR 0x0

void print(char *str);

int main()
{
    int lp_c;
    int lp_v;
    int lp_h;
    int lp_y;
    int lp_x;
    int p_adr;
#ifdef __microblaze__
    u32 uDevId = XPAR_IOMODULE_0_DEVICE_ID;
    XIOModule NfdsIOMdule;
    init_platform();
    //MicroBlaze MCS IOModule Initialize
    XIOModule_Initialize(&NfdsIOMdule, uDevId);
#endif
    //AUARTɋNbZ[WM
    M_PRINT("Start mbmcs_vga_ap v1.00 800x600 60Hz \n\r");
    //BVRAMɃobNOh
      for(lp_v=0;lp_v<600;lp_v++){
    	for(lp_h=0;lp_h<800;lp_h++){
    	  p_adr = VRAM_BASEADDR + (lp_v*800 + lp_h)*2;
    	  (*(volatile unsigned short int *)(p_adr)) = 0x4010; //
    	}
      }
    // VGA/LCD Core SVGA(800x600) 40MHz
    //C@HTIM h_tmg plus=0x7f=127 delay=0x57=87 gate=0x31f=799
    VGA_HTIM = 0x7f57031f;
    //D@VTIM v_tmg plus=3 delay=0x16=22 gate=0x257=599
    VGA_VTIM = 0x03160257;
    //E@HVLEN  h_len=0x41f=1055 v_len=0x273=627
    VGA_HVLEN = 0x041f0273;
    //F@VBARa =0x0
    VGA_VBARA = VGA_VRAM_BASEADDR;
    //VBARb =0x0
    VGA_VBARB = VGA_VRAM_BASEADDR;
    //G@CTRL VLS=1 HLS=1 CD=11 VBL=11 VEN=1
    VGA_CTRL = 0x3381;
    while(1){
      //H@摜f[^
      for(lp_c=0;lp_c < 4;lp_c++){//FύX
        for(lp_v=0;lp_v<6;lp_v++){//cubNw
          for(lp_h=0;lp_h<8;lp_h++){//ubNw
            for(lp_y=0;lp_y<80;lp_y++){//ubNW
              for(lp_x=0;lp_x<80;lp_x++){//ubN
                //IAhXvZ x[XAhX +((yW)*800{ixWj)*2 <-16rbg[hȂ̂2{
              	p_adr = VRAM_BASEADDR + ((lp_v*100 + lp_y+10)*800+(lp_h*100 + lp_x + 10))*2 ;
          	    if (lp_c==0)
          	      (*(volatile unsigned short int *)(p_adr)) = 0xf100;//
          	    else if (lp_c == 1)
        	      (*(volatile unsigned short int *)(p_adr)) = 0x7e0; //
          	    else if (lp_c == 2)
        	      (*(volatile unsigned short int *)(p_adr)) = 0x1f;  //
          	    else
        	      (*(volatile unsigned short int *)(p_adr)) = 0xffff;//
              }
            }
          }
    	}
      }
    }
    return 0;
}
